QGIS Application - Bug report #11905
QgsLayerTreeModel: presence of embedded legend breaks ModelTest
2014-12-22 07:14 AM - Sandro Santilli

Status: Closed

Priority: Normal

Assignee: Martin Dobias

Category: Map Legend

Affected QGIS version:2.6.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 20115
Description

A single project with an embedded legend fails an assertion in ModelTester.
Ho to reproduce:

1. Build with -DENABLE_MODELTEST=ON

2. Add a vector layer

The default legend for vector layer seems to be embedded, so that QgsLayerTreeModel::rowCount() for it returns 0.

But when the legend item was added, the addition triggered a begininsertRows was called promising a new row would have been added
instead.

The ModelTester catches that discrepancy and crashes.

I don't know which way things should go (counting in embedded legends or skipping them elsewhere). Also | don't see if it could be
possible to have multiple embedded legends in a layer...

History

#1 - 2014-12-22 07:39 AM - Sandro Santilli

Whaht does it mean exactly for a legend node to be embedded in parent's node ? It's not documented here:

https://github.com/qgis/QGIS/blob/master/src/core/layertree/qgslayertreemodellegendnode.h#L63-L64

#2 - 2014-12-22 07:51 AM - Martin Dobias

Legend node embedded in parent means that the legend node will be not displayed in the view as a separate item under the layer's item, rather the legend
node's icon should be used for the layer item. This is used e.g. with single symbol renderer - mainly to conserve vertical space in the view. The embedding
should happen if there is only one legend node generated and that flag is enabled. That means you can have cases where there is just one legend node

but it is intentionally not embedded.

It seems like begininsertRows should not be called at all in case of embedded legend node.

#3 - 2014-12-22 08:00 AM - Sandro Santilli

The following patch fixes the crash indeed, but | see begininsertRows being also called from other places
diff --git a/src/core/layertree/qgslayertreemodel.cpp b/src/core/layertree/qgslayertreemodel.cpp
index de62624..bcfddc3 100644

--- a/src/core/layertree/qgslayertreemodel.cpp

+++ b/src/core/layertree/qgslayertreemodel.cpp
https://github.com/qgis/QGIS/blob/master/src/core/layertree/qgslayertreemodellegendnode.h#L63-L64

@@ -800,7 +800,9 @@ void QgslLayerTreeModel::addLegendTolLayer( QgsLayerTreeLayer* nodeL )

QList<QgsLayerTreeModelLegendNode*> filteredLstNew = filterLegendNodes( IstNew );

- begininsertRows( node2index( nodelL ), 0, filteredLstNew.count() - 1);
+ bool isEmbedded = filteredLstNew.count() == 1 && filteredLstNew[0]->isEmbeddedInParent();

+

+ if (! isEmbedded ) beginlnsertRows( node2index( nodeL ), 0, filteredLstNew.count() - 1 );

foreach ( QgsLayerTreeModelLegendNode* n, IstNew )

{

@@ -811,7 +813,7 @@ void QgsLayerTreeModel::addLegendTolLayer( QgsLayerTreeLayer* nodel )
mOriginalLegendNodes[nodeL] = IstNew;
mLegendNodes[nodelL] = filteredLstNew;

- endInsertRows();

+ if (! isEmbedded ) endInsertRows();
}

#4 - 2014-12-22 08:12 AM - Martin Dobias

The patch looks good from a quick look. The other begininsertRows() call handles addition of layer tree nodes, not legend nodes.

#5 - 2014-12-23 01:42 AM - Sandro Santilli

- Target version set to Version 2.8
- Resolution set to fixed/implemented

Thanks for review, patch pushed as commit:32079ed3cf7cf851515c63ed01cb994169f45963 -- not sure if this is worth backporting to 2.6 branch, if

anyone feels strong about it please state so here and repoen for the purpose.

#6 - 2015-01-03 05:36 PM - Martin Dobias
- Status changed from Open to Closed
